
        .NOLIST
        .XCREF
        INCLUDE \masm32\include\masm32rt.inc
        .686
        INCLUDE \masm32\macros\timers.asm

;-------------------------------------------------------------------------------------------------------------------

PAlgn4  PROTO   :DWORD
ShowCpu PROTO   :DWORD

;-------------------------------------------------------------------------------------------------------------------

results MACRO   algo

LOCAL   tmp$
        tmp$    CATSTR <print str$(eax),9,"cycles for >,<algo>,<, ">
        tmp$
        @CatStr(<mov eax,>,<algo>,<_endp>)
        @CatStr(<sub eax,>,<algo>)

;        ifidn <algo>,<parseTable>
;                add     eax,ptEnd-pt+1
;        elseifidn <algo>,<parseTableS>
;                add     eax,ptEndS-ptS+1
;        elseifidn <algo>,<parseDave>
;                add eax,ptEndS-ptS+1         ;we treat it as if the standard jumps had been used
;                ;add eax,Build_T-Build+1
;        endif

        print   str$(eax)," bytes ",9,"#h="
        print   str$(NumH),",#dots="
        print   str$(NumDots),13,10

        ENDM

;-------------------------------------------------------------------------------------------------------------------

LOOP_COUNT = 100000

;-------------------------------------------------------------------------------------------------------------------

        .DATA

;;;;        ALIGN   16
; Source string resembles a number format, i.e. contains 22% dots and h characters
Src1    db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
        db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
        db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
        db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
        db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h",0
;;;;        ALIGN   16
Src2    db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h",0
;;;;        ALIGN   16
Src3    db "1234.5678h",0

        .DATA?

        ALIGN   4
NumH    dd ?
NumDots dd ?

XlatTbl db 256 dup(?)

;-------------------------------------------------------------------------------------------------------------------

        .CODE

_main   PROC

        INVOKE  ShowCpu,1
        call    PBuild

sct     =       0
        REPEAT  3
sct     =       sct+1

        counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
                @CatStr(<invoke PAlgn4,offset Src>,%sct)
        counter_end

        results PAlgn4
        print   chr$(13,10)

        ENDM

        inkey   chr$("--- ok ---",13)
        exit

_main   ENDP

;-------------------------------------------------------------------------------------------------------------------

        .LIST
        ALIGN   16

PAlgn4  PROC    USES esi edi Src:DWORD

        xor     eax,eax
        mov     NumH,eax
        mov     NumDots,eax

        mov     esi,Src
        mov     edi,offset Parse0
        mov     ecx,3

Parse0: test    esi,ecx
        mov     eax,ecx
        jz      Parse1

        mov     al,[esi]
        mov     al,XlatTbl[eax]
        inc     esi
        add     eax,offset Class0
        jmp     eax

Parse1: mov     ecx,104h
        mov     edi,offset Parse2

Parse2: xor     eax,eax
        dec     ch
        jz      Parse4

Parse3: mov     al,dl
        mov     al,XlatTbl[eax]
        shr     edx,8
        add     eax,offset Class0
        jmp     eax

Parse4: mov     edx,[esi]
        add     esi,ecx
        mov     ch,cl
        jmp     Parse3

        ALIGN   16
Class0::
        inc     NumH
        jmp     edi

        ALIGN   16
Class1::
        inc     NumDots

        ALIGN   16
Class2::
        jmp     edi

        ALIGN   16
Class3::
        ret

PAlgn4  ENDP
PAlgn4_endp:
        .NOLIST

;-------------------------------------------------------------------------------------------------------------------

PBuild  PROC

        cld
        mov     edi,offset XlatTbl
        mov     edx,offset Class0
        mov     ecx,256
        mov     eax,offset Class2
        push    edi
        sub     eax,edx
        rep     stosb
        pop     edi
        mov     eax,offset Class3
        sub     eax,edx
        mov     [edi],al
        mov     eax,offset Class1
        sub     eax,edx
        mov     [edi+2Eh],al
        xor     eax,eax
        mov     [edi+48h],al
        mov     [edi+68h],al
        ret

PBuild  ENDP

;-------------------------------------------------------------------------------------------------------------------

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD
	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;-------------------------------------------------------------------------------------------------------------------

        END     _main

[url=\masm32\RichMasm\XorSubMov0_cyct.asc]Last file with cyct macros[/url]

		if 0
			jmp dword ptr [ChTableS+4*eax]		; slowest
		elseif 0
			mov eax, [edi+4*eax]					; fast
			jmp eax
		else
			jmp dword ptr [edi+4*eax]			; fastest on P4
		endif

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]

